Index: src/backend/utils/init/globals.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/utils/init/globals.c,v
retrieving revision 1.97
diff -c -r1.97 globals.c
*** src/backend/utils/init/globals.c	5 Mar 2006 15:58:46 -0000	1.97
--- src/backend/utils/init/globals.c	20 Mar 2006 17:54:42 -0000
***************
*** 93,98 ****
--- 93,99 ----
  bool		enableFsync = true;
  bool		allowSystemTableMods = false;
  int			work_mem = 1024;
+ int         merge_buffers = 32;
  int			maintenance_work_mem = 16384;
  
  /* Primary determinants of sizes of shared-memory structures: */
Index: src/backend/utils/misc/guc.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/utils/misc/guc.c,v
retrieving revision 1.314
diff -c -r1.314 guc.c
*** src/backend/utils/misc/guc.c	7 Mar 2006 02:54:23 -0000	1.314
--- src/backend/utils/misc/guc.c	20 Mar 2006 17:54:48 -0000
***************
*** 1175,1180 ****
--- 1175,1191 ----
  	},
  
  	{
+ 		{"merge_buffers", PGC_USERSET, RESOURCES_MEM,
+ 			gettext_noop("Sets the maximum memory to be used for query workspaces."),
+ 			gettext_noop("This much memory may be used by each internal "
+ 						 "sort operation and hash table before switching to "
+ 						 "temporary disk files.")
+ 		},
+ 		&merge_buffers,
+ 		32, 4, 256, NULL, NULL
+ 	},
+ 
+ 	{
  		{"maintenance_work_mem", PGC_USERSET, RESOURCES_MEM,
  			gettext_noop("Sets the maximum memory to be used for maintenance operations."),
  			gettext_noop("This includes operations such as VACUUM and CREATE INDEX.")
Index: src/backend/utils/sort/tuplesort.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/utils/sort/tuplesort.c,v
retrieving revision 1.65
diff -c -r1.65 tuplesort.c
*** src/backend/utils/sort/tuplesort.c	10 Mar 2006 23:19:00 -0000	1.65
--- src/backend/utils/sort/tuplesort.c	20 Mar 2006 17:54:50 -0000
***************
*** 1231,1237 ****
  	 * the MERGE_BUFFER_SIZE workspace.
  	 */
  	mOrder = (allowedMem - TAPE_BUFFER_OVERHEAD) /
! 		(MERGE_BUFFER_SIZE + TAPE_BUFFER_OVERHEAD);
  
  	/* Even in minimum memory, use at least a MINORDER merge */
  	mOrder = Max(mOrder, MINORDER);
--- 1231,1237 ----
  	 * the MERGE_BUFFER_SIZE workspace.
  	 */
  	mOrder = (allowedMem - TAPE_BUFFER_OVERHEAD) /
! 		((BLCKSZ * merge_buffers) + TAPE_BUFFER_OVERHEAD);
  
  	/* Even in minimum memory, use at least a MINORDER merge */
  	mOrder = Max(mOrder, MINORDER);
Index: src/include/miscadmin.h
===================================================================
RCS file: /projects/cvsroot/pgsql/src/include/miscadmin.h,v
retrieving revision 1.186
diff -c -r1.186 miscadmin.h
*** src/include/miscadmin.h	5 Mar 2006 15:58:53 -0000	1.186
--- src/include/miscadmin.h	20 Mar 2006 17:54:51 -0000
***************
*** 201,206 ****
--- 201,207 ----
  extern bool enableFsync;
  extern bool allowSystemTableMods;
  extern DLLIMPORT int work_mem;
+ extern DLLIMPORT int merge_buffers;
  extern DLLIMPORT int maintenance_work_mem;
  
  extern int	VacuumCostPageHit;
